/*
/////    SAPC APCA - Advanced Perceptual Contrast Algorithm
/////           Beta 0.0.98G-4g W3 ? contrast function only
/////           DIST: W3 Revision date: Nov 29, 2021
/////    Function to parse color values and determine Lc contrast
/////    Copyright © 2019-2021 by Andrew Somers. All Rights Reserved.
/////    LICENSE:  W3 LICENSE
/////    CONTACT: For SAPC/APCA Please use the ISSUES tab at:
/////    https://github.com/Myndex/SAPC-APCA/
/////    Usage:
/////    First color must be text, second color must be the background.
/////
/////    Lc = APCAcontrast(sRGBtoY(textColor),sRGBtoY(backgroundColor));
// */

function sRGBtoY(a){if("string"===typeof a)if(a=parseString(a)){var c=a[0];var d=a[1];a=a[2]}else return-1;else if("number"===typeof a)c=(a&16711680)>>16,d=(a&65280)>>8,a&=255;else return-2;return.2126729*Math.pow(c/255,2.4)+.7151522*Math.pow(d/255,2.4)+.072175*Math.pow(a/255,2.4)}
function APCAcontrast(a,c){var d=[0,1.1];if(isNaN(a)||isNaN(c)||Math.min(a,c)<d[0]||Math.max(a,c)>d[1])return 0;a=.022<a?a:a+Math.pow(.022-a,1.414);c=.022<c?c:c+Math.pow(.022-c,1.414);if(5E-4>Math.abs(c-a))return 0;c>a?(d=1.14*(Math.pow(c,.56)-Math.pow(a,.57)),d=.1>d?0:d-.027):(d=1.14*(Math.pow(c,.65)-Math.pow(a,.62)),d=-.1<d?0:d+.027);return Math.round(100*d)}
function parseString(a){a=(void 0===a?"#abcdef":a).replace(/[\s `~!@#$%^&*<>?{}:;"'+=_-]/g,"");a=a.toLowerCase();var c={aliceblue:"f0f8ff",antiquewhite:"faebd7",aqua:"00ffff",aquamarine:"7fffd4",azure:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"000000",blanchedalmond:"ffebcd",blue:"0000ff",blueviolet:"8a2be2",brown:"a52a2a",burlywood:"deb887",cadetblue:"5f9ea0",chartreuse:"7fff00",chocolate:"d2691e",coral:"ff7f50",cornflowerblue:"6495ed",cornsilk:"fff8dc",crimson:"dc143c",cyan:"00ffff",darkblue:"00008b",
darkcyan:"008b8b",darkgoldenrod:"b8860b",darkgray:"a9a9a9",darkgreen:"006400",darkgrey:"a9a9a9",darkkhaki:"bdb76b",darkmagenta:"8b008b",darkolivegreen:"556b2f",darkorange:"ff8c00",darkorchid:"9932cc",darkred:"8b0000",darksalmon:"e9967a",darkseagreen:"8fbc8f",darkslateblue:"483d8b",darkslategray:"2f4f4f",darkslategrey:"2f4f4f",darkturquoise:"00ced1",darkviolet:"9400d3",deeppink:"ff1493",deepskyblue:"00bfff",dimgray:"696969",dimgrey:"696969",dodgerblue:"1e90ff",firebrick:"b22222",floralwhite:"fffaf0",
forestgreen:"228b22",fuchsia:"ff00ff",gainsboro:"dcdcdc",ghostwhite:"f8f8ff",gold:"ffd700",goldenrod:"daa520",gray:"808080",green:"008000",greenyellow:"adff2f",grey:"808080",honeydew:"f0fff0",hotpink:"ff69b4",indianred:"cd5c5c",indigo:"4b0082",ivory:"fffff0",khaki:"f0e68c",lavender:"e6e6fa",lavenderblush:"fff0f5",lawngreen:"7cfc00",lemonchiffon:"fffacd",lightblue:"add8e6",lightcoral:"f08080",lightcyan:"e0ffff",lightgoldenrodyellow:"fafad2",lightgray:"d3d3d3",lightgreen:"90ee90",lightgrey:"d3d3d3",
lightpink:"ffb6c1",lightsalmon:"ffa07a",lightseagreen:"20b2aa",lightskyblue:"87cefa",lightslategray:"778899",lightslategrey:"778899",lightsteelblue:"b0c4de",lightyellow:"ffffe0",lime:"00ff00",limegreen:"32cd32",linen:"faf0e6",magenta:"ff00ff",maroon:"800000",mediumaquamarine:"66cdaa",mediumblue:"0000cd",mediumorchid:"ba55d3",mediumpurple:"9370db",mediumseagreen:"3cb371",mediumslateblue:"7b68ee",mediumspringgreen:"00fa9a",mediumturquoise:"48d1cc",mediumvioletred:"c71585",midnightblue:"191970",mintcream:"f5fffa",
mistyrose:"ffe4e1",moccasin:"ffe4b5",navajowhite:"ffdead",navy:"000080",oldlace:"fdf5e6",olive:"808000",olivedrab:"6b8e23",orange:"ffa500",orangered:"ff4500",orchid:"da70d6",palegoldenrod:"eee8aa",palegreen:"98fb98",paleturquoise:"afeeee",palevioletred:"db7093",papayawhip:"ffefd5",peachpuff:"ffdab9",peru:"cd853f",pink:"ffc0cb",plum:"dda0dd",powderblue:"b0e0e6",purple:"800080",rebeccapurple:"663399",red:"ff0000",rosybrown:"bc8f8f",royalblue:"4169e1",saddlebrown:"8b4513",salmon:"fa8072",sandybrown:"f4a460",
seagreen:"2e8b57",seashell:"fff5ee",sienna:"a0522d",silver:"c0c0c0",skyblue:"87ceeb",slateblue:"6a5acd",slategray:"708090",slategrey:"708090",snow:"fffafa",springgreen:"00ff7f",steelblue:"4682b4",tan:"d2b48c",teal:"008080",thistle:"d8bfd8",tomato:"ff6347",turquoise:"40e0d0",violet:"ee82ee",wheat:"f5deb3",white:"ffffff",whitesmoke:"f5f5f5",yellow:"ffff00",yellowgreen:"9acd32",gray1:"111111",gray2:"222222",gray3:"333333",gray4:"444444",gray5:"555555",gray6:"666666",gray7:"777777",gray8:"888888",gray9:"999999",
graya:"aaaaaa",grayb:"bbbbbb",grayc:"cccccc",grayd:"dddddd",graye:"eeeeee",grey1:"111111",grey2:"222222",grey3:"333333",grey4:"444444",grey5:"555555",grey6:"666666",grey7:"777777",grey8:"888888",grey9:"999999",greya:"aaaaaa",greyb:"bbbbbb",greyc:"cccccc",greyd:"dddddd",greye:"eeeeee"};for(d in c)if(a==d){a=c[d];break}c=[{rex:/^rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)$/,parseStr:function(b){return[parseInt(b[1]),parseInt(b[2]),parseInt(b[3])]}},{rex:/^([0-9|a-f])([0-9|a-f])([0-9|a-f])$/i,parseStr:function(b){return[parseInt(b[1]+
b[1],16),parseInt(b[2]+b[2],16),parseInt(b[3]+b[3],16)]}},{rex:/^([0-9|a-f])([0-9|a-f])([0-9|a-f])([0-9|a-f])$/i,parseStr:function(b){return[parseInt(b[1]+b[1],16),parseInt(b[2]+b[2],16),parseInt(b[3]+b[3],16),parseInt(b[4]+b[4],16)]}},{rex:/^([0-9|a-f]{2})([0-9|a-f]{2})([0-9|a-f]{2})$/i,parseStr:function(b){return[parseInt(b[1],16),parseInt(b[2],16),parseInt(b[3],16)]}},{rex:/^([0-9|a-f]{2})([0-9|a-f]{2})([0-9|a-f]{2})([0-9|a-f]{2})$/i,parseStr:function(b){return[parseInt(b[1],16),parseInt(b[2],
16),parseInt(b[3],16),parseInt(b[4],16)]}}];var d=c.length;for(var f,e=0;e<d;e++)if(f=c[e].rex,f=f.exec(a))return e=c[e].parseStr(f),a=e[0]&255,c=e[1]&255,d=e[2]&255,isNaN(e[3])?this.a=255:this.a=e[3]&255,[a,c,d,255];return a};

